'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

var DefaultContext = {
  color: undefined,
  size: undefined,
  className: undefined,
  style: undefined,
  attr: undefined
};
var IconContext = React__default.createContext && React__default.createContext(DefaultContext);

var __assign = undefined && undefined.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = undefined && undefined.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  return t;
};

function Tree2Element(tree) {
  return tree && tree.map(function (node, i) {
    return React__default.createElement(node.tag, __assign({
      key: i
    }, node.attr), Tree2Element(node.child));
  });
}

function GenIcon(data) {
  return function (props) {
    return React__default.createElement(IconBase, __assign({
      attr: __assign({}, data.attr)
    }, props), Tree2Element(data.child));
  };
}
function IconBase(props) {
  var elem = function (conf) {
    var computedSize = props.size || conf.size || "1em";
    var className;
    if (conf.className) className = conf.className;
    if (props.className) className = (className ? className + ' ' : '') + props.className;

    var attr = props.attr,
        svgProps = __rest(props, ["attr"]);

    return React__default.createElement("svg", __assign({
      stroke: "currentColor",
      fill: "currentColor",
      strokeWidth: "0"
    }, conf.attr, attr, svgProps, {
      className: className,
      style: __assign({
        color: props.color || conf.color
      }, conf.style, props.style),
      height: computedSize,
      width: computedSize,
      xmlns: "http://www.w3.org/2000/svg"
    }), props.children);
  };

  return IconContext !== undefined ? React__default.createElement(IconContext.Consumer, null, function (conf) {
    return elem(conf);
  }) : elem(DefaultContext);
}

// THIS FILE IS AUTO GENERATED
var FaSearch = function (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 512 512"},"child":[{"tag":"path","attr":{"d":"M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z"}}]})(props);
};
FaSearch.displayName = "FaSearch";
var FaTimes = function (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 352 512"},"child":[{"tag":"path","attr":{"d":"M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"}}]})(props);
};
FaTimes.displayName = "FaTimes";

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".styles_searchbar-collection-container__1PZIK{\r\n  border:2px solid #c5cbd5;\r\n  border-radius: 5px;\r\n  display: inline-flex;\r\n  font-size:20px; \r\n  width:100%;\r\n}\r\n.styles_searchbar-container__2HR6I{\r\n  display: flex;\r\n  flex-grow: 1\r\n}\r\n.styles_searchbar-input__4AkV3 {\r\n  border:0px;\r\n  padding: 8px 28px 8px 8px;\r\n  width:100%;\r\n  font-weight: bold;\r\n}\r\n.styles_searchbar-input__4AkV3::-ms-clear {\r\n  display: none;\r\n}\r\n.styles_searchbar-buttons-container__2oF9K{\r\n display:flex;\r\n justify-content: flex-end;\r\n}\r\n.styles_buttons__VyjNF{\r\n  background: transparent;\r\n  border:0px;\r\n  padding:10px;\r\n  cursor:pointer;\r\n}\r\n.styles_list-autosuggest__3lYRV{\r\n  background-color: #fff;\r\n  border: 1px solid #c5cbd5;\r\n  box-shadow: 4px 6px 16px rgba(48,48,48,.25);\r\n  top: 2px;\r\n  margin-top: 36px;\r\n  left:0px;\r\n  padding:0;\r\n  position: absolute;\r\n  z-index: 999999;\r\n  width:100%;\r\n  list-style: none;\r\n  font-size: 13px;\r\n  cursor:pointer;\r\n}\r\n.styles_list-autosuggest__3lYRV >li{\r\n  width:100%;\r\n  padding: 10px 10px;\r\n  border-bottom:1px solid #c5cbd5;\r\n}\r\n\r\n.styles_active-suggestion__Hz8eU{\r\n  background:lightgray;\r\n}\r\n.styles_list-autosuggest__3lYRV >li:last-child{\r\n  border-bottom:0px;\r\n  text-decoration: none;\r\n  color:#262626\r\n}";
var styles = { "searchbar-collection-container": "styles_searchbar-collection-container__1PZIK", "searchbar-container": "styles_searchbar-container__2HR6I", "searchbar-input": "styles_searchbar-input__4AkV3", "searchbar-buttons-container": "styles_searchbar-buttons-container__2oF9K", "buttons": "styles_buttons__VyjNF", "list-autosuggest": "styles_list-autosuggest__3lYRV", "active-suggestion": "styles_active-suggestion__Hz8eU" };
styleInject(css);

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var Searchbar = function (_Component) {
	inherits(Searchbar, _Component);

	function Searchbar(props) {
		classCallCheck(this, Searchbar);

		var _this = possibleConstructorReturn(this, (Searchbar.__proto__ || Object.getPrototypeOf(Searchbar)).call(this, props));

		_this.showAutosuggest = function () {
			_this.setState({
				suggestions: _this.props.prompt.filter(function (option) {
					return option.toLowerCase().indexOf(_this.state.search.toLowerCase()) === 0;
				})
			}, function () {
				if (_this.state.suggestions.length > 0) {
					_this.setState({ displaySuggestions: true });
				}
			});
		};

		_this.node = React__default.createRef();
		_this.state = {
			search: '',
			displaySuggestions: false,
			suggestions: [],
			cursor: 0,
			SuggestionCount: 0
		};
		return _this;
	}

	createClass(Searchbar, [{
		key: 'searchInput',
		value: function searchInput(event) {
			var _this2 = this;

			event.persist();
			var text = event.target.value;

			if (event.target.value) {
				this.setState({ search: text }, function () {
					if (_this2.state.search.length >= 2 && _this2.props.prompt) {
						_this2.showAutosuggest();
					}
				});
				if (this.props.handleFieldChange) {
					this.props.handleFieldChange(text);
				}
			} else {
				this.clearSearch();
			}
		}
	}, {
		key: 'suggestionClick',
		value: function suggestionClick(item, event) {
			if (item === 'See more link') {
				this.expandList();
			} else {
				event.persist();
				var suggestion = item;
				this.setState({ search: item });
				this.props.handleSelectSuggestion(suggestion);
				this.resetSuggestions(event);
			}
		}
	}, {
		key: 'resetSuggestions',
		value: function resetSuggestions(event) {
			this.setState({ displaySuggestions: false, suggestions: [], cursor: 0 });
		}
	}, {
		key: 'handleSuggestNav',
		value: function handleSuggestNav(event) {
			var _this3 = this;

			event.persist();
			var _state = this.state,
			    cursor = _state.cursor,
			    suggestions = _state.suggestions;

			switch (event.keyCode) {
				case 13:
					if (this.state.cursor !== this.props.autosuggestCount) {
						this.setState({
							search: this.state.suggestions[this.state.cursor],
							results: {},
							isLoaded: true,
							displaySuggestions: false
						});
					} else {
						event.preventDefault();
						this.expandList();
						this.setState({ search: this.state.suggestions[this.props.autosuggestCount] });
					}
					break;
				case 38:
					if (cursor > 0) {
						event.preventDefault();
						this.setState({
							cursor: this.state.cursor - 1
						}, function () {
							_this3.setState({
								search: _this3.state.suggestions[_this3.state.cursor]
							});
						});
					}
					break;
				case 40:
					if (cursor < suggestions.length - 1 && cursor < this.state.SuggestionCount) {
						this.setState({
							cursor: this.state.cursor + 1
						}, function () {
							if (_this3.state.cursor !== _this3.state.SuggestionCount) _this3.setState({
								search: _this3.state.suggestions[_this3.state.cursor]
							});
						});
					}
					break;
				case 27:
					this.resetSuggestions();
					break;
			}
		}
	}, {
		key: 'clearSearch',
		value: function clearSearch() {
			this.setState({
				results: {},
				isLoaded: true,
				displaySuggestions: false,
				search: '',
				SuggestionCount: this.props.autosuggestCount,
				cursor: 0
			});
		}
	}, {
		key: 'submitHandler',
		value: function submitHandler(event) {
			event.persist();
			event.preventDefault();
			this.props.handleSearch();
		}
	}, {
		key: 'expandList',
		value: function expandList() {
			this.setState({ SuggestionCount: this.state.suggestions.length });
			document.querySelector('#searchbar-input').focus();
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			document.addEventListener('mousedown', this.closeSuggestions.bind(this), false);
			this.setState({ SuggestionCount: this.props.autosuggestCount });
		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate() {
			console.log(this.node);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			document.addEventListener('mousedown', this.closeSuggestions.bind(this), false);
		}
	}, {
		key: 'closeSuggestions',
		value: function closeSuggestions(event) {
			if (event.target.contains(this.node.current)) {
				this.resetSuggestions();
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _React$createElement,
			    _this4 = this;

			return React__default.createElement(
				'form',
				{
					onSubmit: this.submitHandler.bind(this)
				},
				React__default.createElement(
					'div',
					{ className: styles["searchbar-collection-container"] },
					React__default.createElement(
						'div',
						{ className: styles["searchbar-container"] },
						React__default.createElement('input', (_React$createElement = {
							type: 'text',
							onKeyDown: this.handleSuggestNav.bind(this),
							id: 'searchbar-input',
							name: 'searchbar-input',
							className: styles["searchbar-input"],
							onChange: this.searchInput.bind(this)
						}, defineProperty(_React$createElement, 'name', 'st'), defineProperty(_React$createElement, 'value', this.state.search), defineProperty(_React$createElement, 'maxLength', '90'), defineProperty(_React$createElement, 'placeholder', 'Search'), defineProperty(_React$createElement, 'aria-label', 'Type to search. Navigate below to hear suggestions'), defineProperty(_React$createElement, 'autoComplete', 'off'), defineProperty(_React$createElement, 'autoCorrect', 'off'), defineProperty(_React$createElement, 'autocapitolize', 'off'), defineProperty(_React$createElement, 'spellCheck', 'false'), _React$createElement)),
						this.state.displaySuggestions && this.state.search && React__default.createElement(
							'ul',
							{ ref: this.node, className: styles["list-autosuggest"], 'aria-label': 'Suggested Results' },
							this.state.suggestions.map(function (item, index) {
								return React__default.createElement(
									React__default.Fragment,
									{ key: index },
									index + 1 <= _this4.state.SuggestionCount && React__default.createElement(
										'li',
										{
											className: _this4.state.cursor === index ? styles["active-suggestion"] : null,
											'data-index': index,
											key: index,
											onClick: _this4.suggestionClick.bind(_this4, item)
										},
										React__default.createElement(
											'span',
											{ className: styles["autosuggest-links"] },
											React__default.createElement(
												'strong',
												null,
												item.substring(0, _this4.state.search.length)
											),
											item.substring(_this4.state.search.length, item.length)
										)
									)
								);
							}),
							this.state.suggestions.length > this.state.SuggestionCount && React__default.createElement(
								'li',
								{
									'data-index': this.state.SuggestionCount,
									onClick: this.suggestionClick.bind(this, "See more link"),
									className: this.state.cursor === this.state.SuggestionCount ? styles["active-suggestion"] : null
								},
								React__default.createElement(
									'a',
									{ href: 'javascript:void(0)', onClick: this.expandList.bind(this) },
									'See more results'
								)
							)
						)
					),
					React__default.createElement(
						'div',
						{ className: styles["searchbar-buttons-container"] },
						this.state.search && React__default.createElement(
							'button',
							{ id: 'clear-button',
								type: 'button',
								'aria-label': 'Clear search text',
								className: 'buttons',
								onClick: this.clearSearch.bind(this)
							},
							React__default.createElement(FaTimes, null)
						),
						React__default.createElement(
							'button',
							{ type: 'submit', className: styles["buttons"], 'aria-label': 'submit search', title: 'Search' },
							React__default.createElement(FaSearch, null)
						)
					)
				)
			);
		}
	}]);
	return Searchbar;
}(React.Component);

module.exports = Searchbar;
//# sourceMappingURL=index.js.map
